<script lang="ts" context="module">
	import queryString from "query-string"

	export async function load({ fetch, page, session }) {
		const projectId = page.query.get("project") || session.config.projectId
		const ref = page.query.get("ref") || "HEAD"

		if (!projectId) {
			return {
				status: 400,
				error: "Project ID must be given either from config or query string parameter",
			}
		}

		const datapackageUrl = queryString.stringifyUrl({
			url: "/datapackage.json",
			query: {
				project: projectId,
				ref,
			},
		})
		const response = await fetch(datapackageUrl)
		if (!response.ok) {
			throw new Error((await response.json()).error)
		}
		const datapackage: any = await response.json()

		const projectUrl = new URL(projectId, session.config.gitlabUrl).toString()

		// Transform resource paths mentioned in datapackage.json to absolute URLs.
		datapackage.resources = datapackage.resources.map((resource) => ({
			path: resource.path,
			url: `${projectUrl}/-/raw/${ref}/${resource.path}`,
		}))

		return {
			props: { datapackage, projectId, projectUrl },
		}
	}
</script>

<script lang="ts">
	export let datapackage
	export let projectId
	export let projectUrl

	import { session } from "$app/stores"

	const adminUiUrl = queryString.stringifyUrl({
		url: new URL("/data-packages/contribute", $session.config.adminUiUrl).toString(),
		query: { project: projectId },
	})
</script>

<div class="prose prose-lg max-w-none mx-4 md:mx-16 xl:mx-64 my-16">
	<h1>{datapackage.name}</h1>
	<p>{datapackage.description}</p>

	{#if datapackage.resources}
		<h2>Files</h2>
		<ul>
			{#each datapackage.resources as resource}
				<li><a href={resource.url} rel="external" target="_blank">{resource.path}</a></li>
			{/each}
		</ul>
	{/if}

	<h2>Source</h2>
	<a href={projectUrl} rel="external" target="_blank">{projectUrl}</a>

	<h2>Contribution</h2>
	<a href={adminUiUrl}>Click here to propose an improvement to this project</a>
</div>
